diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/spectrum-wifi-phy.h ns-3.43/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.42/src/wifi/model/spectrum-wifi-phy.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/spectrum-wifi-phy.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Ghada Badawy <gbadawy@gmail.com>
@@ -31,6 +20,7 @@
 
 #include <map>
 #include <optional>
+#include <vector>
 
 class SpectrumWifiPhyFilterTest;
 
@@ -76,9 +66,9 @@
     void SetDevice(const Ptr<WifiNetDevice> device) override;
     void StartTx(Ptr<const WifiPpdu> ppdu) override;
     Ptr<Channel> GetChannel() const override;
-    uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const override;
-    std::tuple<double, double, double> GetTxMaskRejectionParams() const override;
-    WifiSpectrumBandInfo GetBand(uint16_t bandWidth, uint8_t bandIndex = 0) override;
+    MHz_u GetGuardBandwidth(MHz_u currentChannelWidth) const override;
+    std::tuple<dBr_u, dBr_u, dBr_u> GetTxMaskRejectionParams() const override;
+    WifiSpectrumBandInfo GetBand(MHz_u bandWidth, uint8_t bandIndex = 0) override;
     FrequencyRange GetCurrentFrequencyRange() const override;
     WifiSpectrumBandFrequencies ConvertIndicesToFrequencies(
         const WifiSpectrumBandIndices& indices) const override;
@@ -134,16 +124,16 @@
                                           Time duration);
 
     /**
-     * Configure a non-active spectrum PHY interface to operate on a given frequency with a given
-     * width. The function searches for the non-active PHY interface that operates on the frequency
-     * range corresponding to the spectrum portion specified by the caller. It takes care to
-     * configure the RX spectrum model of the PHY interface and to update the bands tracked in
-     * interference helper.
+     * Configure a non-active spectrum PHY interface to operate on a given frequency (or several
+     * frequencies for non-contiguous) with a given total width. The function searches for the
+     * non-active PHY interface that operates on the frequency range corresponding to the spectrum
+     * portion specified by the caller. It takes care to configure the RX spectrum model of the PHY
+     * interface and to update the bands tracked in interference helper.
      *
-     * \param frequency the center frequency in MHz the PHY interface should use
-     * \param width the channel width in MHz the PHY interface should use
+     * \param frequencies the center frequency of each segment the PHY interface should use
+     * \param width the total channel width the PHY interface should use
      */
-    void ConfigureInterface(uint16_t frequency, uint16_t width);
+    void ConfigureInterface(const std::vector<MHz_u>& frequencies, MHz_u width);
 
     /**
      * This function is sending the signal to the Spectrum channel
@@ -176,6 +166,20 @@
     const std::map<FrequencyRange, Ptr<WifiSpectrumPhyInterface>>& GetSpectrumPhyInterfaces() const;
 
     /**
+     * Determine the number of bands between the two segments if the operating channel is made of
+     * non-contiguous segments, otherwise the function returns zero.
+     *
+     * \param centerFrequencies the center frequency of each segment
+     * \param totalWidth the width of the operating channel
+     * \param subcarrierSpacing the subcarrier spacing
+     * \return the number of bands between the two segments if the operating channel is made of
+     * non-contiguous segments, zero otherwise
+     */
+    static uint32_t GetNumBandsBetweenSegments(const std::vector<MHz_u>& centerFrequencies,
+                                               MHz_u totalWidth,
+                                               uint32_t subcarrierSpacing);
+
+    /**
      * \param callback the callback to invoke when operating channel has switched.
      */
     void SetChannelSwitchedCallback(Callback<void> callback);
@@ -196,15 +200,18 @@
                                        //!< reasons)
 
   private:
+    void FinalizeChannelSwitch() override;
+
     /**
      * Perform run-time spectrum model change
      * \param spectrumPhyInterface the spectrum PHY interface for which the spectrum model should be
-     * changed \param centerFrequency the center frequency in MHz the PHY interface should use
-     * \param channelWidth the channel width in MHz the PHY interface should use
+     * changed
+     * \param centerFrequencies the center frequency of each segment the PHY interface should use
+     * \param channelWidth the total channel width the PHY interface should use
      */
     void ResetSpectrumModel(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
-                            uint16_t centerFrequency,
-                            uint16_t channelWidth);
+                            const std::vector<MHz_u>& centerFrequencies,
+                            MHz_u channelWidth);
 
     /**
      * This function is called to update the bands handled by the InterferenceHelper.
@@ -216,11 +223,11 @@
      * This function computes the RU bands that belong to a given spectrum PHY interface.
      *
      * \param spectrumPhyInterface the spectrum PHY interface to consider to compute the RU bands
-     * \param guardBandwidth width of the guard band in MHz
+     * \param guardBandwidth width of the guard band
      * \returns the computed RU bands for the spectrum PHY interface
      */
     HeRuBands GetHeRuBands(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
-                           uint16_t guardBandwidth);
+                           MHz_u guardBandwidth);
 
     /**
      * This function computes the bands that belong to a given spectrum PHY interface.
@@ -234,13 +241,13 @@
      * Get the info of a given band that belongs to a given spectrum PHY interface
      *
      * \param spectrumPhyInterface the spectrum PHY interface
-     * \param bandWidth the width of the band to be returned (MHz)
+     * \param bandWidth the width of the band to be returned
      * \param bandIndex the index of the band to be returned
      *
      * \return the info that defines the band
      */
     WifiSpectrumBandInfo GetBandForInterface(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
-                                             uint16_t bandWidth,
+                                             MHz_u bandWidth,
                                              uint8_t bandIndex = 0);
 
     /**
@@ -267,12 +274,12 @@
     /**
      * Get the spectrum PHY interface that covers a band portion of the RF channel
      *
-     * \param frequency the center frequency in MHz of the RF channel band
-     * \param width the width in MHz of the RF channel band
+     * \param frequency the center frequency of the RF channel band
+     * \param width the width of the RF channel band
      * \return the spectrum PHY interface that covers the indicated band of the RF channel
      */
-    Ptr<WifiSpectrumPhyInterface> GetInterfaceCoveringChannelBand(uint16_t frequency,
-                                                                  uint16_t width) const;
+    Ptr<WifiSpectrumPhyInterface> GetInterfaceCoveringChannelBand(MHz_u frequency,
+                                                                  MHz_u width) const;
 
     /**
      * Notify the spectrum channel has switched
@@ -284,16 +291,18 @@
     bool m_disableWifiReception;           //!< forces this PHY to fail to sync on any signal
     bool m_trackSignalsInactiveInterfaces; //!< flag whether signals coming from inactive spectrum
                                            //!< PHY interfaces are tracked
+    std::vector<MHz_u> m_frequenciesBeforeSwitch; //!< center frequency before channel switch
+    std::vector<MHz_u> m_widthsBeforeSwitch;      //!< channel width before channel switch
 
     TracedCallback<Ptr<const SpectrumSignalParameters>, uint32_t, double, Time>
         m_signalCb; //!< Signal callback
 
-    double m_txMaskInnerBandMinimumRejection; //!< The minimum rejection (in dBr) for the inner band
-                                              //!< of the transmit spectrum mask
-    double m_txMaskOuterBandMinimumRejection; //!< The minimum rejection (in dBr) for the outer band
-                                              //!< of the transmit spectrum mask
-    double m_txMaskOuterBandMaximumRejection; //!< The maximum rejection (in dBr) for the outer band
-                                              //!< of the transmit spectrum mask
+    dBr_u m_txMaskInnerBandMinimumRejection; //!< The minimum rejection for the inner band of the
+                                             //!< transmit spectrum mask
+    dBr_u m_txMaskOuterBandMinimumRejection; //!< The minimum rejection for the outer band of the
+                                             //!< transmit spectrum mask
+    dBr_u m_txMaskOuterBandMaximumRejection; //!< The maximum rejection for the outer band of the
+                                             //!< transmit spectrum mask
 
     Callback<void> m_channelSwitchedCallback; //!< Callback when channel switched
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ssid.cc ns-3.43/src/wifi/model/ssid.cc
--- ns-3.42/src/wifi/model/ssid.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/ssid.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ssid.h ns-3.43/src/wifi/model/ssid.h
--- ns-3.42/src/wifi/model/ssid.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/ssid.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/status-code.cc ns-3.43/src/wifi/model/status-code.cc
--- ns-3.42/src/wifi/model/status-code.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/status-code.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/status-code.h ns-3.43/src/wifi/model/status-code.h
--- ns-3.42/src/wifi/model/status-code.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/status-code.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/sta-wifi-mac.cc ns-3.43/src/wifi/model/sta-wifi-mac.cc
--- ns-3.42/src/wifi/model/sta-wifi-mac.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/sta-wifi-mac.cc	2024-10-09 16:41:10.128656900 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -201,6 +190,11 @@
         m_emlsrManager->Dispose();
     }
     m_emlsrManager = nullptr;
+    for (auto& [phyId, event] : m_emlsrLinkSwitch)
+    {
+        event.Cancel();
+    }
+    m_emlsrLinkSwitch.clear();
     WifiMac::DoDispose();
 }
 
@@ -311,8 +305,8 @@
 StaWifiMac::GetCurrentChannel(uint8_t linkId) const
 {
     auto phy = GetWifiPhy(linkId);
-    uint16_t width = phy->GetOperatingChannel().IsOfdm() ? 20 : phy->GetChannelWidth();
-    uint8_t ch = phy->GetOperatingChannel().GetPrimaryChannelNumber(width, phy->GetStandard());
+    const auto width = phy->GetOperatingChannel().IsOfdm() ? 20 : phy->GetChannelWidth();
+    uint8_t ch = phy->GetPrimaryChannelNumber(width);
     return {ch, phy->GetPhyBand()};
 }
 
@@ -396,7 +390,7 @@
 
     if (!GetQosSupported())
     {
-        GetTxop()->Queue(packet, hdr);
+        GetTxop()->Queue(Create<WifiMpdu>(packet, hdr));
     }
     // "A QoS STA that transmits a Management frame determines access category used
     // for medium access in transmission of the Management frame as follows
@@ -407,7 +401,7 @@
     //   shall be selected." (Sec. 10.2.3.2 of 802.11-2020)
     else
     {
-        GetVOQueue()->Queue(packet, hdr);
+        GetVOQueue()->Queue(Create<WifiMpdu>(packet, hdr));
     }
 }
 
@@ -684,7 +678,7 @@
 
     if (!GetQosSupported())
     {
-        GetTxop()->Queue(packet, hdr);
+        GetTxop()->Queue(Create<WifiMpdu>(packet, hdr));
     }
     // "A QoS STA that transmits a Management frame determines access category used
     // for medium access in transmission of the Management frame as follows
@@ -695,11 +689,11 @@
     //   shall be selected." (Sec. 10.2.3.2 of 802.11-2020)
     else if (!GetWifiRemoteStationManager(linkId)->GetQosSupported(*link.bssid))
     {
-        GetBEQueue()->Queue(packet, hdr);
+        GetBEQueue()->Queue(Create<WifiMpdu>(packet, hdr));
     }
     else
     {
-        GetVOQueue()->Queue(packet, hdr);
+        GetVOQueue()->Queue(Create<WifiMpdu>(packet, hdr));
     }
 
     if (m_assocRequestEvent.IsPending())
@@ -960,10 +954,17 @@
 Mac48Address
 StaWifiMac::DoGetLocalAddress(const Mac48Address& remoteAddr) const
 {
-    auto linkIds = GetSetupLinkIds();
-    NS_ASSERT_MSG(!linkIds.empty(), "Not associated");
-    uint8_t linkId = *linkIds.begin();
-    return GetFrameExchangeManager(linkId)->GetAddress();
+    for (const auto& [id, link] : GetLinks())
+    {
+        if (GetStaLink(link).bssid == remoteAddr)
+        {
+            // the remote address is the address of the (single link) AP we are associated with;
+            return link->feManager->GetAddress();
+        }
+    }
+
+    // the remote address is unknown
+    return GetAddress();
 }
 
 bool
@@ -973,88 +974,35 @@
 }
 
 void
-StaWifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to)
+StaWifiMac::NotifyDropPacketToEnqueue(Ptr<Packet> packet, Mac48Address to)
 {
     NS_LOG_FUNCTION(this << packet << to);
-    if (!CanForwardPacketsTo(to))
-    {
-        NotifyTxDrop(packet);
-        TryToEnsureAssociated();
-        return;
-    }
-    WifiMacHeader hdr;
+    TryToEnsureAssociated();
+}
 
-    // If we are not a QoS AP then we definitely want to use AC_BE to
-    // transmit the packet. A TID of zero will map to AC_BE (through \c
-    // QosUtilsMapTidToAc()), so we use that as our default here.
-    uint8_t tid = 0;
-
-    // For now, an AP that supports QoS does not support non-QoS
-    // associations, and vice versa. In future the AP model should
-    // support simultaneously associated QoS and non-QoS STAs, at which
-    // point there will need to be per-association QoS state maintained
-    // by the association state machine, and consulted here.
-    if (GetQosSupported())
-    {
-        hdr.SetType(WIFI_MAC_QOSDATA);
-        hdr.SetQosAckPolicy(WifiMacHeader::NORMAL_ACK);
-        hdr.SetQosNoEosp();
-        hdr.SetQosNoAmsdu();
-        // Transmission of multiple frames in the same TXOP is not
-        // supported for now
-        hdr.SetQosTxopLimit(0);
-
-        // Fill in the QoS control field in the MAC header
-        tid = QosUtilsGetTidForPacket(packet);
-        // Any value greater than 7 is invalid and likely indicates that
-        // the packet had no QoS tag, so we revert to zero, which'll
-        // mean that AC_BE is used.
-        if (tid > 7)
-        {
-            tid = 0;
-        }
-        hdr.SetQosTid(tid);
-    }
-    else
-    {
-        hdr.SetType(WIFI_MAC_DATA);
-    }
-    if (GetQosSupported())
-    {
-        hdr.SetNoOrder(); // explicitly set to 0 for the time being since HT control field is not
-                          // yet implemented (set it to 1 when implemented)
-    }
+void
+StaWifiMac::Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from)
+{
+    NS_LOG_FUNCTION(this << *mpdu << to << from);
+
+    auto& hdr = mpdu->GetHeader();
 
     // the Receiver Address (RA) and the Transmitter Address (TA) are the MLD addresses only for
     // non-broadcast data frames exchanged between two MLDs
     auto linkIds = GetSetupLinkIds();
     NS_ASSERT(!linkIds.empty());
     uint8_t linkId = *linkIds.begin();
-    if (const auto apMldAddr = GetWifiRemoteStationManager(linkId)->GetMldAddress(GetBssid(linkId)))
-    {
-        hdr.SetAddr1(*apMldAddr);
-        hdr.SetAddr2(GetAddress());
-    }
-    else
-    {
-        hdr.SetAddr1(GetBssid(linkId));
-        hdr.SetAddr2(GetFrameExchangeManager(linkId)->GetAddress());
-    }
+    const auto apMldAddr = GetWifiRemoteStationManager(linkId)->GetMldAddress(GetBssid(linkId));
 
+    hdr.SetAddr1(apMldAddr.value_or(GetBssid(linkId)));
+    hdr.SetAddr2(apMldAddr ? GetAddress() : GetFrameExchangeManager(linkId)->GetAddress());
     hdr.SetAddr3(to);
     hdr.SetDsNotFrom();
     hdr.SetDsTo();
 
-    if (GetQosSupported())
-    {
-        // Sanity check that the TID is valid
-        NS_ASSERT(tid < 8);
-        GetQosTxop(tid)->Queue(packet, hdr);
-    }
-    else
-    {
-        GetTxop()->Queue(packet, hdr);
-    }
+    auto txop = hdr.IsQosData() ? StaticCast<Txop>(GetQosTxop(hdr.GetQosTid())) : GetTxop();
+    NS_ASSERT(txop);
+    txop->Queue(mpdu);
 }
 
 void
@@ -1210,9 +1158,7 @@
         }
 
     default:
-        // Invoke the receive handler of our parent class to deal with any
-        // other frames. Specifically, this will handle Block Ack-related
-        // Management Action frames.
+        // Invoke the receive handler of our parent class to deal with any other frames
         WifiMac::Receive(mpdu, linkId);
     }
 
@@ -1510,8 +1456,8 @@
     // STAs operating on setup links may need to transition to a new PM mode after the
     // acknowledgement of the Association Response. For this purpose, we connect a callback to
     // the PHY TX begin trace to catch the Ack transmitted after the Association Response.
-    CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, double>(
-        [=, this](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
+    CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, Watt_u>(
+        [=, this](WifiConstPsduMap psduMap, WifiTxVector txVector, Watt_u /* txPower */) {
             NS_ASSERT_MSG(psduMap.size() == 1 && psduMap.begin()->second->GetNMpdus() == 1 &&
                               psduMap.begin()->second->GetHeader(0).IsAck(),
                           "Expected a Normal Ack after Association Response frame");
@@ -2101,6 +2047,13 @@
         newLink.stationManager->SetupPhy(phy);
     };
 
+    // cancel any pending event for the given PHY to switch link
+    if (auto eventIt = m_emlsrLinkSwitch.find(phy->GetPhyId()); eventIt != m_emlsrLinkSwitch.end())
+    {
+        eventIt->second.Cancel();
+        m_emlsrLinkSwitch.erase(eventIt);
+    }
+
     // if there is no PHY operating on the new link, connect the PHY to the new link now.
     // Otherwise, wait until the channel switch is completed, so that the PHY operating on the new
     // link can possibly continue receiving frames in the meantime.
@@ -2110,7 +2063,7 @@
     }
     else
     {
-        Simulator::Schedule(delay, connectPhy);
+        m_emlsrLinkSwitch.emplace(phy->GetPhyId(), Simulator::Schedule(delay, connectPhy));
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/sta-wifi-mac.h ns-3.43/src/wifi/model/sta-wifi-mac.h
--- ns-3.42/src/wifi/model/sta-wifi-mac.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/sta-wifi-mac.h	2024-10-09 16:41:10.128656900 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -187,15 +176,6 @@
     StaWifiMac();
     ~StaWifiMac() override;
 
-    /**
-     * \param packet the packet to send.
-     * \param to the address to which the packet should be sent.
-     *
-     * The packet should be enqueued in a TX queue, and should be
-     * dequeued as soon as the channel access function determines that
-     * access is granted to this MAC.
-     */
-    void Enqueue(Ptr<Packet> packet, Mac48Address to) override;
     bool CanForwardPacketsTo(Mac48Address to) const override;
     int64_t AssignStreams(int64_t stream) override;
 
@@ -410,6 +390,8 @@
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     std::unique_ptr<LinkEntity> CreateLinkEntity() const override;
     Mac48Address DoGetLocalAddress(const Mac48Address& remoteAddr) const override;
+    void Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from) override;
+    void NotifyDropPacketToEnqueue(Ptr<Packet> packet, Mac48Address to) override;
 
     /**
      * Process the Beacon frame received on the given link.
@@ -603,21 +585,23 @@
     void DoInitialize() override;
     void DoDispose() override;
 
-    MacState m_state;                       ///< MAC state
-    uint16_t m_aid;                         ///< Association AID
-    Ptr<WifiAssocManager> m_assocManager;   ///< Association Manager
-    Ptr<EmlsrManager> m_emlsrManager;       ///< EMLSR Manager
-    Time m_waitBeaconTimeout;               ///< wait beacon timeout
-    Time m_probeRequestTimeout;             ///< probe request timeout
-    Time m_assocRequestTimeout;             ///< association request timeout
-    EventId m_assocRequestEvent;            ///< association request event
-    uint32_t m_maxMissedBeacons;            ///< maximum missed beacons
-    EventId m_beaconWatchdog;               //!< beacon watchdog
-    Time m_beaconWatchdogEnd{0};            //!< beacon watchdog end
-    bool m_activeProbing;                   ///< active probing
-    Ptr<RandomVariableStream> m_probeDelay; ///< RandomVariable used to randomize the time
-                                            ///< of the first Probe Response on each channel
-    Time m_pmModeSwitchTimeout;             ///< PM mode switch timeout
+    MacState m_state;                             ///< MAC state
+    uint16_t m_aid;                               ///< Association AID
+    Ptr<WifiAssocManager> m_assocManager;         ///< Association Manager
+    Ptr<EmlsrManager> m_emlsrManager;             ///< EMLSR Manager
+    Time m_waitBeaconTimeout;                     ///< wait beacon timeout
+    Time m_probeRequestTimeout;                   ///< probe request timeout
+    Time m_assocRequestTimeout;                   ///< association request timeout
+    EventId m_assocRequestEvent;                  ///< association request event
+    uint32_t m_maxMissedBeacons;                  ///< maximum missed beacons
+    EventId m_beaconWatchdog;                     //!< beacon watchdog
+    Time m_beaconWatchdogEnd{0};                  //!< beacon watchdog end
+    bool m_activeProbing;                         ///< active probing
+    Ptr<RandomVariableStream> m_probeDelay;       ///< RandomVariable used to randomize the time
+                                                  ///< of the first Probe Response on each channel
+    Time m_pmModeSwitchTimeout;                   ///< PM mode switch timeout
+    std::map<uint8_t, EventId> m_emlsrLinkSwitch; ///< maps PHY ID to the event scheduled to switch
+                                                  ///< the corresponding PHY to a new EMLSR link
 
     /// store the DL TID-to-Link Mapping included in the Association Request frame
     WifiTidLinkMapping m_dlTidLinkMappingInAssocReq;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/supported-rates.cc ns-3.43/src/wifi/model/supported-rates.cc
--- ns-3.42/src/wifi/model/supported-rates.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/supported-rates.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/supported-rates.h ns-3.43/src/wifi/model/supported-rates.h
--- ns-3.42/src/wifi/model/supported-rates.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/supported-rates.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
